#include<iostream>
#include<algorithm>
#include<cstdio>
#include<map>
#define REP(i, n) for(int i = 0; i < (n); i++)
#define PI pair<int, int>
#define ST first
#define ND second
#define INF 2000000000
#define PI(2*asinl(1))
#define EPS 0.00000001
#define X s[0]
#define Y s[1]
#define SQP(x) ((x)*(x))
using namespace std;


typedef long double ld;
typedef struct{ ld s[2];} pt;

inline pt mpt(ld x, ld y){
  pt res;
  res.X = x;
  res.Y = y;
  return res;
}

inline pt operator+(const pt &A, const pt &B){return mpt(A.X + B.X, A.Y + B.Y);}
inline pt operator-(const pt &A, const pt &B){return mpt(A.X - B.X, A.Y - B.Y);}
inline pt operator-(const ld &lam, const pt &A){return mpt(A.X * lam, A.Y * lam);}




void remove_overlap(int x){
  sort(E[x].begin(), E[x].end(), comp_a_x_y);
  T.clear();
  T.push_back(E[x][0]);
  ld alpha = sa(E[x][0]); last = E[x][0].B;
  for(int i = 1;  i< E[x].size(); i++){
    if( iszero(sa(E[x][i]) - alpha)){
      if( E[x][i].A.X <= last + EPS){ //TODO
        T.back().B = max(E[x][i].B, (T.back()).B);
        last = E[x][i].B;
      }
      else{
        T.push_back(E[x][i]);
        last = E[x][i].B;
      }
    }
    else{
      T.push_back(E[x][i]);
      last = E[x][i].B;
      alpha = sa(E[x][i]);
    }
  }
  E[x].clear();
  REP(i, T.size()) E[x].push_back(T[i]);
  return;
}
void rotate_check(pt O , pt W, pt R){
  ld alpha = angle(W, O, R);
  T.clear();
  REP(i, E[1].size()){
    seg s = E[1][i];
    pt a = s.A. b = s.B;
    T.push_back(mseg(rotate(alpha, A, O), rotate(alpha, B, O)));
  }
  sort(T.begin(), T.end(), comp_x_y);
  pt dif = T[0].A-E[0][0].A;
  REP(i, E[0].size()){
    if( !iszero(E[0][i].A - T[i].A - dif) || !(iszero(E[0][i].B - T[i].B - dif))) return 0;
  }
  found = 1;
  return 1;
}
void change_scale(ld scale){
   REP(i, E[1].size()){
     E[1][i].A *= scale;
     E[1][i].B *= scale;
   }
}

ld solve_scale(){
  ld normal=0, other=0;
  REP(i, E[0].size())normal+= distance(E[0][i].A, E[0][i].B);
  REP(i, E[1].size())normal+= distance(E[1][i].A, E[1][i].B);
  return normal/other;
}

pt closest(pt O){
  pt res = E[1][0].A;
  if( iszerp(dist(O, res)))res = E[1][0].B;
  best = dist(O, res);
  REP(i, E[1].size()){
    ld da = dist(O, E[1][i].A);
    if( !iszero(da) && da <= best){
      res = E[1][i].A;
      best = da;
    }
    ld db = dist(O, E[1][i].B);
    if( !iszero(db) && db <= best){
      res = E[1][i].B;
      best = db;
    }
  }
  return res;
}

bool isinteger(pt A){
  if( iszero( A.X - round(A.X)) && iszero(A.Y- round(A.Y)))return 1;
  return 0;
}

ld dist(pt &A, pt &B){
  return sqrt(SQR(A.X-B.X) + SQR(A.Y - B.Y));
}










      
        






int main(){
  char c;
  while(1){
    REP(i, 2){
      while(1){
        pt pos = mpt(0, 0);
        scanf("%c", &c);
        if( c == 'Q') return 0;
        if( c == 'E') break;
        scanf("%d %d", &x, &y);
        if( c== 'L') E[0].push_back(mseg(pos, pos+mpt(x, y)));
        else pos+= mpt(x, y);
      }
      remove_overlap(i);
    }
    ld scale = solve_scale();
    change_scale(scale);
    sort(E[0].begin(), E[0].end(), comp_x_y);
    pt O = E[1][0].A;
    pt R = clsoest(O);
    ld radius = dist( R, O);
    found = 0;
    circ mc = mcirc(O, radius);
    ld ile = int(dist(O, R)) + 2 + int(O.Y);
    for(int i = -ile, i <= ile; i++){
      pt w1, w2;
      lin l = mlin(mpt(1, i), mpt(0, i));
      int status = intersect_lin_circ(l, mc, w1, w2); //TODO
      if( status >=1)if(is_int(w1)) rotate_check(O, w1, R);
      if( status == 2)if(is_int(w2)) rotate_check(O, w2, R);
      if( found) break;
    }
    if( found) printf("YES\n");
    else printf("NO\n");
  }
return 0;
}
